diff -urN qmail-1.03-vanilla/qmail-local.c qmail-1.03-md24/qmail-local.c
--- qmail-1.03-vanilla/qmail-local.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-local.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,5 +1,7 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
+#include <fcntl.h>
 #include "readwrite.h"
 #include "sig.h"
 #include "env.h"
@@ -29,17 +31,18 @@
 #include "gfrom.h"
 #include "auto_patrn.h"
 
-void usage() { strerr_die1x(100,"qmail-local: usage: qmail-local [ -nN ] user homedir local dash ext domain sender aliasempty"); }
+char *overquota = "5.2.2 Recipient's mailbox is full, message returned to sender.";
 
-void temp_nomem() { strerr_die1x(111,"Out of memory. (#4.3.0)"); }
-void temp_rewind() { strerr_die1x(111,"Unable to rewind message. (#4.3.0)"); }
-void temp_childcrashed() { strerr_die1x(111,"Aack, child crashed. (#4.3.0)"); }
-void temp_fork() { strerr_die3x(111,"Unable to fork: ",error_str(errno),". (#4.3.0)"); }
-void temp_read() { strerr_die3x(111,"Unable to read message: ",error_str(errno),". (#4.3.0)"); }
-void temp_slowlock()
-{ strerr_die1x(111,"File has been locked for 30 seconds straight. (#4.3.0)"); }
-void temp_qmail(fn) char *fn;
-{ strerr_die5x(111,"Unable to open ",fn,": ",error_str(errno),". (#4.3.0)"); }
+void usage()
+{ strerr_die1x(100,"qmail-local: usage: qmail-local [ -nN ] user homedir local dash ext domain sender aliasempty"); }
+
+void temp_nomem() { strerr_die1x(111,"4.3.0 out of memory"); }
+void temp_rewind() { strerr_die1x(111,"4.3.0 unable to rewind message"); }
+void temp_childcrashed() { strerr_die1x(111,"4.3.0 aack, child crashed"); }
+void temp_fork() { strerr_die2x(111,"4.3.0 unable to fork: ",error_str(errno)); }
+void temp_read() { strerr_die2x(111,"4.3.0 unable to read message: ",error_str(errno)); }
+void temp_slowlock() { strerr_die1x(111,"4.3.0 file has been locked for 30 seconds straight"); }
+void temp_qmail(fn) char *fn; { strerr_die4x(111,"4.3.0 unable to open ",fn,": ",error_str(errno)); }
 
 int flagdoit;
 int flag99;
@@ -110,7 +113,10 @@
 
  alarm(86400);
  fd = open_excl(fntmptph);
- if (fd == -1) _exit(1);
+ if (fd == -1) {
+   if (errno == error_dquot) _exit(5);
+   else _exit(1);
+ }
 
  substdio_fdbuf(&ss,read,0,buf,sizeof(buf));
  substdio_fdbuf(&ssout,write,fd,outbuf,sizeof(outbuf));
@@ -128,10 +134,17 @@
  if (close(fd) == -1) goto fail; /* NFS dorks */
 
  if (link(fntmptph,fnnewtph) == -1) goto fail;
+ if ((fd = open(fnnewtph, O_RDONLY)) < 0 || fsync(fd) < 0 || close(fd) < 0)
+   goto fail;
    /* if it was error_exist, almost certainly successful; i hate NFS */
  tryunlinktmp(); _exit(0);
 
- fail: tryunlinktmp(); _exit(1);
+ fail: 
+   if (errno == error_dquot) {
+     tryunlinktmp(); _exit(5);
+   } else {
+     tryunlinktmp(); _exit(1);
+   }
 }
 
 /* end child process */
@@ -159,10 +172,11 @@
  switch(wait_exitcode(wstat))
   {
    case 0: break;
-   case 2: strerr_die1x(111,"Unable to chdir to maildir. (#4.2.1)");
-   case 3: strerr_die1x(111,"Timeout on maildir delivery. (#4.3.0)");
-   case 4: strerr_die1x(111,"Unable to read message. (#4.3.0)");
-   default: strerr_die1x(111,"Temporary error on maildir delivery. (#4.3.0)");
+   case 2: strerr_die1x(111,"4.2.1 unable to chdir to maildir");
+   case 3: strerr_die1x(111,"4.3.0 timeout on maildir delivery");
+   case 4: strerr_die1x(111,"4.3.0 unable to read message");
+   case 5: strerr_die1x(100,overquota);
+   default: strerr_die1x(111,"4.3.0 temporary error on maildir delivery");
   }
 }
 
@@ -180,7 +194,7 @@
 
  fd = open_append(fn);
  if (fd == -1)
-   strerr_die5x(111,"Unable to open ",fn,": ",error_str(errno),". (#4.2.1)");
+   strerr_die4x(111,"4.2.1 unable to open ",fn,": ",error_str(errno));
 
  sig_alarmcatch(temp_slowlock);
  alarm(30);
@@ -200,7 +214,7 @@
   {
    if (getln(&ss,&messline,&match,'\n') != 0) 
     {
-     strerr_warn3("Unable to read message: ",error_str(errno),". (#4.3.0)",0);
+     strerr_warn2("4.3.0 unable to read message: ",error_str(errno),0);
      if (flaglocked) seek_trunc(fd,pos); close(fd);
      _exit(111);
     }
@@ -221,7 +235,12 @@
  return;
 
  writeerrs:
- strerr_warn5("Unable to write ",fn,": ",error_str(errno),". (#4.3.0)",0);
+ if (errno == error_dquot) { 
+   if (flaglocked) seek_trunc(fd,pos);
+   close(fd);
+   strerr_die1x(100,overquota);
+ } else
+ strerr_warn4("4.3.0 unable to write ",fn,": ",error_str(errno),0);
  if (flaglocked) seek_trunc(fd,pos);
  close(fd);
  _exit(111);
@@ -244,7 +263,7 @@
      args[0] = "/bin/sh"; args[1] = "-c"; args[2] = prog; args[3] = 0;
      sig_pipedefault();
      execv(*args,args);
-     strerr_die3x(111,"Unable to run /bin/sh: ",error_str(errno),". (#4.3.0)");
+     strerr_die2x(111,"4.3.0 unable to run /bin/sh: ",error_str(errno));
   }
 
  wait_pid(&wstat,child);
@@ -304,7 +323,7 @@
      break;
    if (messline.len == dtline.len)
      if (!str_diffn(messline.s,dtline.s,dtline.len))
-       strerr_die1x(100,"This message is looping: it already has my Delivered-To line. (#5.4.6)");
+       strerr_die1x(100,"5.4.6 this message is looping: it already has my Delivered-To line");
   }
 }
 
@@ -313,14 +332,16 @@
  struct stat st;
 
  if (stat(".",&st) == -1)
-   strerr_die3x(111,"Unable to stat home directory: ",error_str(errno),". (#4.3.0)");
+   strerr_die2x(111,"4.3.0 unable to stat home directory: ",error_str(errno));
  if (st.st_mode & auto_patrn)
-   strerr_die1x(111,"Uh-oh: home directory is writable. (#4.7.0)");
- if (st.st_mode & 01000)
-   if (flagdoit)
-     strerr_die1x(111,"Home directory is sticky: user is editing his .qmail file. (#4.2.1)");
-   else
+   strerr_die1x(111,"4.7.0 uh-oh: home directory is writable");
+ if (st.st_mode & 01000) {
+   if (flagdoit) {
+     strerr_die1x(111,"4.2.1 home directory is sticky: user is editing his .qmail file");
+   } else {
      strerr_warn1("Warning: home directory is sticky.",0);
+   }
+ }
 }
 
 int qmeox(dashowner)
@@ -360,7 +381,7 @@
   if (fstat(*fd,&st) == -1) temp_qmail(qme.s);
   if ((st.st_mode & S_IFMT) == S_IFREG) {
     if (st.st_mode & auto_patrn)
-      strerr_die1x(111,"Uh-oh: .qmail file is writable. (#4.7.0)");
+      strerr_die1x(111,"4.7.0 uh-oh: .qmail file is writable");
     *cutable = !!(st.st_mode & 0100);
     return 1;
   }
@@ -444,7 +465,7 @@
  substdio_putsflush(subfdoutsmall,"\n");
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -488,7 +509,7 @@
 
  if (homedir[0] != '/') usage();
  if (chdir(homedir) == -1)
-   strerr_die5x(111,"Unable to switch to ",homedir,": ",error_str(errno),". (#4.3.0)");
+   strerr_die4x(111,"4.3.0 unable to switch to ",homedir,": ",error_str(errno));
  checkhome();
 
  if (!env_put2("HOST",host)) temp_nomem();
@@ -586,7 +607,7 @@
  qmesearch(&fd,&flagforwardonly);
  if (fd == -1)
    if (*dash)
-     strerr_die1x(100,"Sorry, no mailbox here by that name. (#5.1.1)");
+     strerr_die1x(100,"5.1.1 sorry, no mailbox here by that name");
 
  if (!stralloc_copys(&ueo,sender)) temp_nomem();
  if (str_diff(sender,""))
@@ -645,19 +666,20 @@
     {
      cmds.s[j] = 0;
      k = j;
-     while ((k > i) && (cmds.s[k - 1] == ' ') || (cmds.s[k - 1] == '\t'))
+     while ((k > i) && ((cmds.s[k - 1] == ' ') || (cmds.s[k - 1] == '\t')))
        cmds.s[--k] = 0;
      switch(cmds.s[i])
       {
        case 0: /* k == i */
 	 if (i) break;
-         strerr_die1x(111,"Uh-oh: first line of .qmail file is blank. (#4.2.1)");
+         strerr_die1x(111,"4.2.1 uh-oh: first line of .qmail file is blank");
        case '#':
+       case ':':
          break;
        case '.':
        case '/':
 	 ++count_file;
-	 if (flagforwardonly) strerr_die1x(111,"Uh-oh: .qmail has file delivery but has x bit set. (#4.7.0)");
+	 if (flagforwardonly) strerr_die1x(111,"4.7.0 uh-oh: .qmail has file delivery but has x bit set");
 	 if (cmds.s[k - 1] == '/')
            if (flagdoit) maildir(cmds.s + i);
            else sayit("maildir ",cmds.s + i,k - i);
@@ -667,10 +689,50 @@
          break;
        case '|':
 	 ++count_program;
-	 if (flagforwardonly) strerr_die1x(111,"Uh-oh: .qmail has prog delivery but has x bit set. (#4.7.0)");
+	 if (flagforwardonly) strerr_die1x(111,"4.7.0 uh-oh: .qmail has prog delivery but has x bit set");
          if (flagdoit) mailprogram(cmds.s + i + 1);
          else sayit("program ",cmds.s + i + 1,k - i - 1);
          break;
+       case '?':
+         ++i;
+         {
+           int l;
+           for (l = i;l < k;++l)
+             if (cmds.s[l] == ' ' || cmds.s[l] == '\t') {
+               cmds.s[l] = 0;
+               for (++l;l < k;++l)
+                 if (cmds.s[l] != ' ' && cmds.s[l] != '\t') {
+                   ++count_program;
+                   if (flagforwardonly) strerr_die1x(111,"Uh-oh: .qmail has prog delivery but has x bit set. (#4.7.0)");
+                   if (flagdoit) mailprogram(cmds.s + l);
+                   else sayit("program ",cmds.s + l,k - l);
+                   break;
+                 }
+               break;
+             }
+           if (l == k || flag99) {
+             flag99 = 0;
+             cmds.s[j] = '\n';
+             for (;j + 1 < cmds.len;++j)
+               if (cmds.s[j] == '\n' && cmds.s[j + 1] == ':') {
+                 j += 2;
+                 l = j;
+                 for (; j < cmds.len;++j) {
+                   if (cmds.s[j] == 0) break;
+                   if (cmds.s[j] == '\t') break;
+                   if (cmds.s[j] == '\n') break;
+                   if (cmds.s[j] == ' ') break;
+                 }
+                 if (!str_diffn(cmds.s + i,cmds.s + l,j - l)) {
+                   for (; j < cmds.len;++j)
+                     if (cmds.s[j] == '\n') break;
+                   break;
+                 }
+                 --j;
+               }
+           }
+         }
+         break;
        case '+':
 	 if (str_equal(cmds.s + i + 1,"list"))
 	   flagforwardonly = 1;
diff -urN qmail-1.03-vanilla/qmail-lspawn.c qmail-1.03-md24/qmail-lspawn.c
--- qmail-1.03-vanilla/qmail-lspawn.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-lspawn.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "fd.h"
 #include "wait.h"
 #include "prot.h"
@@ -13,6 +15,8 @@
 #include "auto_qmail.h"
 #include "auto_uids.h"
 #include "qlx.h"
+#include "byte.h"
+#include "open.h"
 
 char *aliasempty;
 
@@ -165,9 +169,8 @@
   }
 }
 
-int spawn(fdmess,fdout,s,r,at)
-int fdmess; int fdout;
-char *s; char *r; int at;
+int
+spawn(int fdmess, int fdout, unsigned long msgsize, char *s, char *r, int at)
 {
  int f;
 
diff -urN qmail-1.03-vanilla/qmail-newmrh.c qmail-1.03-md24/qmail-newmrh.c
--- qmail-1.03-vanilla/qmail-newmrh.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-newmrh.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,6 +1,9 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "strerr.h"
 #include "stralloc.h"
 #include "substdio.h"
+#include "case.h"
 #include "getln.h"
 #include "exit.h"
 #include "readwrite.h"
@@ -29,7 +32,7 @@
 stralloc line = {0};
 int match;
 
-void main()
+int main()
 {
   umask(033);
   if (chdir(auto_qmail) == -1)
diff -urN qmail-1.03-vanilla/qmail-newu.c qmail-1.03-md24/qmail-newu.c
--- qmail-1.03-vanilla/qmail-newu.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-newu.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,9 +1,12 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "stralloc.h"
 #include "subfd.h"
 #include "getln.h"
 #include "substdio.h"
 #include "cdbmss.h"
 #include "exit.h"
+#include "byte.h"
 #include "readwrite.h"
 #include "open.h"
 #include "error.h"
@@ -68,7 +71,7 @@
 
 stralloc wildchars = {0};
 
-void main()
+int main()
 {
   int i;
   int numcolons;
diff -urN qmail-1.03-vanilla/qmail-p0f.c qmail-1.03-md24/qmail-p0f.c
--- qmail-1.03-vanilla/qmail-p0f.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/qmail-p0f.c	2007-07-19 20:56:22.000000000 +0200
@@ -0,0 +1,90 @@
+#include "qmail-p0f.h"
+
+char *p0fos, *p0fdetails, *p0flink;
+char p0fdistance;
+signed int p0fuptime;
+char p0ffw,p0fnat;
+
+void p0f_received(struct qmail *qqt, char *remoteip)
+{
+  char buf[FMT_ULONG];
+  if (!p0fos) return;
+  qmail_puts(qqt,"X-P0F-Info: ");
+  safeput(qqt,remoteip?remoteip:"unknown");
+  qmail_puts(qqt," is-a ");
+  if (p0ffw) qmail_puts(qqt,"firewalled ");
+  if (p0fnat) qmail_puts(qqt,"NATted ");
+  safeput(qqt,p0fos);
+  qmail_puts(qqt," [");
+  if (p0fdetails) {
+    int i;
+    for (i=0; p0fdetails[i]; ++i) {
+      if (p0fdetails[i]<' ') p0fdetails[i]='?';
+      if (p0fdetails[i]=='[') p0fdetails[i]='(';
+      if (p0fdetails[i]==']') p0fdetails[i]=')';
+    }
+  } else p0fdetails="unknown";
+  qmail_puts(qqt,p0fdetails);
+  qmail_puts(qqt,"]");
+  if (p0flink) {
+    qmail_puts(qqt,", link \"");
+    qmail_puts(qqt,p0flink);
+    qmail_puts(qqt,"\"");
+  }
+  if (p0fdistance) {
+    qmail_puts(qqt,", ");
+    qmail_put(qqt,buf,fmt_ulong(buf,p0fdistance));
+    qmail_puts(qqt," hops away");
+  }
+  if (p0fuptime>-1) {
+    qmail_puts(qqt,", uptime ");
+    qmail_put(qqt,buf,fmt_ulong(buf,p0fuptime));
+  }
+  qmail_puts(qqt,"\n");
+}
+
+/* xxx: prove this */
+void p0f_query(void)
+{
+  int sock;
+  struct sockaddr_un x;
+  struct p0f_query p;
+  struct p0f_response r;
+  char* tmp;
+
+  if (!ctl_p0fsock) return;
+
+  p0fos=p0fdetails=0;
+  p0fdistance=p0ffw=p0fnat=0;
+  p0fuptime=0;
+
+  if (strlen(ctl_p0fsock)+1>sizeof(x.sun_path)) return;
+
+  p.magic=QUERY_MAGIC;
+  p.id=getpid();
+  p.src_ad=(tmp=env_get("TCPREMOTEIP"))?inet_addr(tmp):-1;
+  p.dst_ad=(tmp=env_get("TCPLOCALIP"))?inet_addr(tmp):-1;
+  p.src_port=atoi((tmp=env_get("TCPREMOTEPORT"))?tmp:"0");
+  p.dst_port=atoi((tmp=env_get("TCPLOCALPORT"))?tmp:"0");
+  if (p.src_ad==-1 || p.dst_ad==-1 || !p.src_port || !p.dst_port) return;
+
+  sock=socket(PF_UNIX,SOCK_STREAM,0);
+  if (sock == -1) return;
+  x.sun_family=AF_UNIX;
+  str_copy(x.sun_path, ctl_p0fsock);
+  if (connect(sock,(struct sockaddr*)&x,sizeof(x))) {close(sock);return;}
+  if (write(sock,&p,sizeof(p)) != sizeof(p)) {close(sock);return;}
+  if (read(sock,&r,sizeof(r)) != sizeof(r)) {close(sock);return;}
+  close(sock);
+  if (r.magic != QUERY_MAGIC) return;
+  if (r.type == RESP_BADQUERY || r.type == RESP_NOMATCH) return;
+  if (!r.genre[0]) { p0fos="unknown"; return; }
+
+  p0fos=strdup(r.genre);
+  p0fdetails=strdup(r.detail);
+  p0flink=strdup(r.link);
+  p0fdistance=r.dist;
+  p0fuptime=r.uptime;
+  p0fnat=r.nat;
+  p0ffw=r.fw;
+}
diff -urN qmail-1.03-vanilla/qmail-p0f.h qmail-1.03-md24/qmail-p0f.h
--- qmail-1.03-vanilla/qmail-p0f.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/qmail-p0f.h	2007-07-19 20:56:22.000000000 +0200
@@ -0,0 +1,75 @@
+#ifndef P0F_H
+#define P0F_H
+
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <sys/unistd.h>
+#include <sys/un.h>
+#include <arpa/inet.h>
+#include <stdlib.h>
+
+#include "received.h"
+#include "uint32.h"
+#include "qmail.h"
+#include "fmt.h"
+#include "env.h"
+#include "str.h"
+
+/* from p0f-query.h */
+#define QUERY_MAGIC	0x0defaced
+#define NO_SCORE	-100
+
+/* Masquerade detection flags: */
+#define D_GENRE   0x0001
+#define D_DETAIL  0x0002
+#define D_LINK    0x0004
+#define D_DIST    0x0008
+#define D_NAT     0x0010
+#define D_FW      0x0020
+#define D_NAT2_1  0x0040
+#define D_FW2_1   0x0080
+#define D_NAT2_2  0x0100
+#define D_FW2_2   0x0200
+#define D_FAST    0x0400
+#define D_TNEG    0x0800
+
+#define D_TIME    0x4000
+#define D_FAR     0x8000
+
+struct p0f_query {
+  uint32 magic;			/* must be set to QUERY_MAGIC */
+  uint32 id;			/* Unique query ID */
+  uint32 src_ad,dst_ad;		/* src address, local dst addr */
+  unsigned short src_port,dst_port;	/* src and dst ports */
+};
+
+#define RESP_OK		0	/* Response OK */
+#define RESP_BADQUERY	1	/* Query malformed */
+#define RESP_NOMATCH	2	/* No match for src-dst data */
+
+struct p0f_response {
+  uint32 magic;			/* QUERY_MAGIC */
+  uint32 id;			/* Query ID (copied from p0f_query) */
+  unsigned char  type;		/* RESP_* */
+  unsigned char  genre[20];	/* OS genre (empty if no match) */
+  unsigned char  detail[40];	/* OS version (empty if no match) */
+  char  dist;			/* Distance (-1 if unknown ) */
+  unsigned char  link[30];	/* Link type (empty if unknown) */
+  unsigned char  tos[30];	/* Traffic type (empty if unknown) */
+  unsigned char  fw,nat;	/* firewall and NAT flags flags */
+  unsigned char  real;		/* A real operating system? */
+  signed short score;		/* Masquerade score (or NO_SCORE) */
+  unsigned short mflags;	/* Masquerade flags (D_*) */
+  signed int uptime;		/* Uptime in hours (-1 = unknown) */
+};
+
+extern char *ctl_p0fsock; /* from qmail-smtpd */
+extern char *p0fos, *p0fdetails, *p0flink;
+extern char p0fdistance;
+extern signed int p0fuptime;
+extern char p0ffw,p0fnat;
+
+extern void p0f_received(struct qmail *qqt, char *remoteip);
+extern void p0f_query(void);
+
+#endif /* P0F_H */
diff -urN qmail-1.03-vanilla/qmail-pop3d.c qmail-1.03-md24/qmail-pop3d.c
--- qmail-1.03-vanilla/qmail-pop3d.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-pop3d.c	2007-07-28 18:06:30.000000000 +0200
@@ -1,6 +1,8 @@
 #include <sys/types.h>
 #include <sys/stat.h>
-#include "commands.h"
+#include <unistd.h>
+#include <fcntl.h>
+#include "auto_qmail.h"
 #include "sig.h"
 #include "getln.h"
 #include "stralloc.h"
@@ -9,6 +11,7 @@
 #include "open.h"
 #include "prioq.h"
 #include "scan.h"
+#include "base64.h"
 #include "fmt.h"
 #include "str.h"
 #include "exit.h"
@@ -16,8 +19,26 @@
 #include "readwrite.h"
 #include "timeoutread.h"
 #include "timeoutwrite.h"
+#include "out_log.h"
+#include "case.h"
+#include "env.h"
+#include "commands.h"
+#include "control.h"
+#include "scan.h"
+#include "fd.h"
+#include "wait.h"
+#include "byte.h"
+#include "now.h"
+
+char *name="qmail-pop3d";
+char unique[FMT_ULONG + FMT_ULONG + 3];
+
+int ctl_log_in=0;
+int ctl_log_out=0;
+int ctl_log_fd=2;
+int ctl_maxcmdlen;
 
-void die() { _exit(0); }
+void die() { _exit(1); }
 
 int saferead(fd,buf,len) int fd; char *buf; int len;
 {
@@ -35,78 +56,65 @@
   return r;
 }
 
+char ssinbuf[1024];
 char ssoutbuf[1024];
-substdio ssout = SUBSTDIO_FDBUF(safewrite,1,ssoutbuf,sizeof ssoutbuf);
-
-char ssinbuf[128];
+char sserrbuf[1024];
+char strnum[FMT_ULONG];
+stralloc line = {0};
 substdio ssin = SUBSTDIO_FDBUF(saferead,0,ssinbuf,sizeof ssinbuf);
+substdio ssout = SUBSTDIO_FDBUF(safewrite,1,ssoutbuf,sizeof ssoutbuf);
+substdio sserr = SUBSTDIO_FDBUF(safewrite,-1,sserrbuf,sizeof sserrbuf);
 
-void put(buf,len) char *buf; int len;
-{
-  substdio_put(&ssout,buf,len);
-}
-void puts(s) char *s;
-{
-  substdio_puts(&ssout,s);
-}
-void flush()
+void err(char *s)
 {
-  substdio_flush(&ssout);
+  doserv();
+  out("-ERR");
+  if (s) { out(" "); out(s); }
+  doeol(); flush();
 }
-void err(s) char *s;
-{
-  puts("-ERR ");
-  puts(s);
-  puts("\r\n");
-  flush();
-}
-
-void die_nomem() { err("out of memory"); die(); }
-void die_nomaildir() { err("this user has no $HOME/Maildir"); die(); }
-void die_scan() { err("unable to scan $HOME/Maildir"); die(); }
-
-void err_syntax() { err("syntax error"); }
-void err_unimpl() { err("unimplemented"); }
-void err_deleted() { err("already deleted"); }
-void err_nozero() { err("messages are counted from 1"); }
-void err_toobig() { err("not that many messages"); }
-void err_nosuch() { err("unable to open that message"); }
-void err_nounlink() { err("unable to unlink all deleted messages"); }
 
-void okay() { puts("+OK \r\n"); flush(); }
-
-void printfn(fn) char *fn;
+void err_die(char *s)
 {
-  fn += 4;
-  put(fn,str_chr(fn,':'));
+  err(s);die();
 }
 
-char strnum[FMT_ULONG];
-stralloc line = {0};
+void die_nomaildir() { err_die("[SYS/TEMP] this user has no $HOME/Maildir"); }
+void die_nomem()     { err_die("[SYS/TEMP] out of memory"); }
+void die_scan()      { err_die("[SYS/TEMP] unable to scan $HOME/Maildir"); }
+void die_control()   { err_die("[SYS/TEMP] unable to read controls"); }
+void die_lcmd()      { err_die("[SYS/TEMP] the given command is too long!"); }
+
+void err_noargs()    { err("don't need any arguments"); }
+void err_syntax()    { err("syntax error"); }
+void err_unimpl()    { err("unimplemented"); }
+void err_deleted()   { err("already deleted"); }
+void err_nozero()    { err("messages are counted from 1"); }
+void err_toobig()    { err("not that many messages"); }
+void err_nosuch()    { err("unable to open that message"); }
+void err_nounlink()  { err("unable to unlink all deleted messages"); }
 
 void blast(ssfrom,limit)
-substdio *ssfrom;
-unsigned long limit;
+  substdio *ssfrom;
+  unsigned long limit;
 {
   int match;
   int inheaders = 1;
- 
+
   for (;;) {
     if (getln(ssfrom,&line,&match,'\n') != 0) die();
     if (!match && !line.len) break;
     if (match) --line.len; /* no way to pass this info over POP */
     if (limit) if (!inheaders) if (!--limit) break;
-    if (!line.len)
+    if (!line.len) {
       inheaders = 0;
-    else
-      if (line.s[0] == '.')
-        put(".",1);
-    put(line.s,line.len);
-    put("\r\n",2);
+    } else if (line.s[0] == '.') {
+      Out(".");
+    }
+    Outn(line.s,line.len);Out("\r\n");
     if (!match) break;
   }
-  put("\r\n.\r\n",5);
-  flush();
+  doserv(); Log("[...]"); Out(".");
+  doeol(); flush();
 }
 
 stralloc filenames = {0};
@@ -114,89 +122,127 @@
 
 struct message {
   int flagdeleted;
+  int read;
   unsigned long size;
   char *fn;
 } *m;
 int numm;
 
-int last = 0;
+int last=0;
 
 void getlist()
 {
   struct prioq_elt pe;
   struct stat st;
   int i;
- 
+
   maildir_clean(&line);
   if (maildir_scan(&pq,&filenames,1,1) == -1) die_scan();
- 
+
   numm = pq.p ? pq.len : 0;
   m = (struct message *) alloc(numm * sizeof(struct message));
   if (!m) die_nomem();
- 
-  for (i = 0;i < numm;++i) {
+
+  for (i=0; i<numm; ++i) {
     if (!prioq_min(&pq,&pe)) { numm = i; break; }
     prioq_delmin(&pq);
     m[i].fn = filenames.s + pe.id;
     m[i].flagdeleted = 0;
-    if (stat(m[i].fn,&st) == -1)
-      m[i].size = 0;
-    else
-      m[i].size = st.st_size;
+    m[i].read = 0;
+    if (stat(m[i].fn,&st) == -1) m[i].size = 0;
+    else m[i].size = st.st_size;
   }
 }
 
-void pop3_stat()
+void pop3_noop(char *arg) {
+  if (*arg) { err_noargs(); return; }
+  out_err("+OK");
+}
+
+void pop3_stat(char *arg)
 {
   int i;
-  unsigned long total;
- 
-  total = 0;
-  for (i = 0;i < numm;++i) if (!m[i].flagdeleted) total += m[i].size;
-  puts("+OK ");
-  put(strnum,fmt_uint(strnum,numm));
-  puts(" ");
-  put(strnum,fmt_ulong(strnum,total));
-  puts("\r\n");
-  flush();
+  unsigned long total=0, n=0;
+
+  if (*arg) { err_noargs(); return; }
+  for (i = 0;i < numm;++i) if (!m[i].flagdeleted) total += m[i].size, n++;
+  doserv(); out("+OK ");
+  strnum[fmt_uint(strnum,n)]=0;out(strnum);
+  out(" ");
+  strnum[fmt_ulong(strnum,total)]=0;out(strnum);
+  doeol();flush();
 }
 
-void pop3_rset()
+void pop3_rset(char *arg)
 {
   int i;
+
+  if (*arg) { err_noargs(); return; }
   for (i = 0;i < numm;++i) m[i].flagdeleted = 0;
   last = 0;
-  okay();
+  out_err("+OK");
 }
 
-void pop3_last()
+/* rfc1460
+ *
+ * The POP3 server issues a positive response with a line containing the highest
+ * message number which accessed.
+ * Zero is returned in case no message in the maildrop has been accessed during
+ * previous transactions.
+ * A client may thereafter infer that messages, if any, numbered greater than
+ * the response to the LAST command are messages not yet accessed by the
+ * client.
+ */
+void pop3_last(char *arg)
 {
-  puts("+OK ");
-  put(strnum,fmt_uint(strnum,last));
-  puts("\r\n");
-  flush();
+  int i;
+  char *p;
+
+  if (*arg) { err_noargs(); return; }
+  last = 0;
+  for (i=0; i<numm; i++) {
+    p = m[i].fn;
+    if (m[i].read) last = i + 1;
+    else {
+      int j = str_rchr(p,',');
+      if (p[j]==',')
+       if (p[j + str_chr(p + j,'S')])
+        last = i + 1;
+    }
+  }
+  doserv(); out("+OK ");
+  outn(strnum,fmt_uint(strnum,last));
+  doeol();flush();
 }
 
-void pop3_quit()
+void pop3_quit(char *arg)
 {
   int i;
-  for (i = 0;i < numm;++i)
+
+  if (*arg) { err_noargs(); return; }
+  for (i = 0;i < numm;++i) {
     if (m[i].flagdeleted) {
+      /* if deleted */
       if (unlink(m[i].fn) == -1) err_nounlink();
-    }
-    else
+    } else {
+      /* all other */
       if (str_start(m[i].fn,"new/")) {
-	if (!stralloc_copys(&line,"cur/")) die_nomem();
-	if (!stralloc_cats(&line,m[i].fn + 4)) die_nomem();
-	if (!stralloc_cats(&line,":2,")) die_nomem();
-	if (!stralloc_0(&line)) die_nomem();
-	rename(m[i].fn,line.s); /* if it fails, bummer */
+        if (!stralloc_copys(&line,"cur/")) die_nomem();
+        if (!stralloc_cats(&line,m[i].fn + 4)) die_nomem();
+        if (m[i].read) {
+	  if (!stralloc_cats(&line,":2,S")) die_nomem(); /* seen flag is set */
+	} else {
+	  if (!stralloc_cats(&line,":2,")) die_nomem();
+	}
+        if (!stralloc_0(&line)) die_nomem();
+        rename(m[i].fn,line.s); /* if it fails, bummer */
       }
-  okay();
-  die();
+    }
+  } /* for(all) */
+  out_err("+OK good bye"); _exit(0);
 }
 
-int msgno(arg) char *arg;
+int msgno(char *arg)
 {
   unsigned long u;
   if (!scan_ulong(arg,&u)) { err_syntax(); return -1; }
@@ -207,99 +253,197 @@
   return u;
 }
 
-void pop3_dele(arg) char *arg;
+void pop3_dele(char *arg)
 {
   int i;
   i = msgno(arg);
   if (i == -1) return;
   m[i].flagdeleted = 1;
   if (i + 1 > last) last = i + 1;
-  okay();
+  out_err("+OK");
 }
 
-void list(i,flaguidl)
-int i;
-int flaguidl;
+void printfn(char *fn, int log)
 {
-  put(strnum,fmt_uint(strnum,i + 1));
-  puts(" ");
-  if (flaguidl) printfn(m[i].fn);
-  else put(strnum,fmt_ulong(strnum,m[i].size));
-  puts("\r\n");
+  fn += 4;
+  if (log) outn(fn,str_chr(fn,':'));
+  else Outn(fn,str_chr(fn,':'));
 }
 
-void dolisting(arg,flaguidl) char *arg; int flaguidl;
+void list(int i, int flaguidl, int log)
+{
+  if (log) {
+    outn(strnum,fmt_uint(strnum,i + 1)); out(" ");
+    if (flaguidl) printfn(m[i].fn, log);
+    else outn(strnum,fmt_ulong(strnum,m[i].size));
+    doeol();
+  } else {
+    /* big listings are not logged! */
+    Outn(strnum,fmt_uint(strnum,i + 1)); Out(" ");
+    if (flaguidl) printfn(m[i].fn, log);
+    else Outn(strnum,fmt_ulong(strnum,m[i].size));
+    Out("\r\n");
+  }
+  flush();
+}
+
+/* +OK 2 messages (320 octets) */
+void dolisting(char *arg, int flaguidl)
 {
   unsigned int i;
+
   if (*arg) {
     i = msgno(arg);
     if (i == -1) return;
-    puts("+OK ");
-    list(i,flaguidl);
-  }
-  else {
-    okay();
-    for (i = 0;i < numm;++i)
-      if (!m[i].flagdeleted)
-	list(i,flaguidl);
-    puts(".\r\n");
+    doserv(); out("+OK "); list(i,flaguidl,1);
+  } else {
+    unsigned long total=0,n=0;
+    for (i=0; i<numm; ++i) if (!m[i].flagdeleted) total += m[i].size, n++;
+    doserv(); out("+OK ");
+    strnum[fmt_uint(strnum,n)]=0;out(strnum);
+    out(" messages (");
+    strnum[fmt_ulong(strnum,total)]=0;out(strnum);
+    out(" octets)"); doeol();
+    for (i=0; i<numm; ++i) if (!m[i].flagdeleted) list(i,flaguidl,0);
+    doserv(); Log("[...]"); Out(".");
+    doeol();
   }
   flush();
 }
 
-void pop3_uidl(arg) char *arg; { dolisting(arg,1); }
-void pop3_list(arg) char *arg; { dolisting(arg,0); }
+void pop3_uidl(char *arg) { dolisting(arg,1); }
+void pop3_list(char *arg) { dolisting(arg,0); }
 
 substdio ssmsg; char ssmsgbuf[1024];
 
-void pop3_top(arg) char *arg;
+void pop3_top(char *arg)
 {
   int i;
   unsigned long limit;
   int fd;
- 
+
   i = msgno(arg);
   if (i == -1) return;
- 
+
   arg += scan_ulong(arg,&limit);
   while (*arg == ' ') ++arg;
   if (scan_ulong(arg,&limit)) ++limit; else limit = 0;
- 
+
   fd = open_read(m[i].fn);
   if (fd == -1) { err_nosuch(); return; }
-  okay();
+  doserv();
+  out("+OK (");outn(strnum, fmt_ulong(strnum,m[i].size));out(" octets)");
+  doeol();flush();
   substdio_fdbuf(&ssmsg,read,fd,ssmsgbuf,sizeof(ssmsgbuf));
   blast(&ssmsg,limit);
+  m[i].read = 1;
   close(fd);
 }
 
+void pop3_capa(arg) char *arg;
+{
+  out_err("+OK Capability list follows");
+  out_err("TOP");
+  out_err("UIDL");
+  out_err("LAST");
+  out_err("PIPELINING");
+  out_err("RESP-CODES");
+  out_err("IMPLEMENTATION qmail patched " VERSION);
+  out_err(".");
+  flush();
+}
+
 struct commands pop3commands[] = {
   { "quit", pop3_quit, 0 }
+, { "capa", pop3_capa, 0 }
 , { "stat", pop3_stat, 0 }
 , { "list", pop3_list, 0 }
 , { "uidl", pop3_uidl, 0 }
 , { "dele", pop3_dele, 0 }
-, { "retr", pop3_top, 0 }
 , { "rset", pop3_rset, 0 }
 , { "last", pop3_last, 0 }
-, { "top", pop3_top, 0 }
-, { "noop", okay, 0 }
+, { "retr", pop3_top,  0 }
+, { "top",  pop3_top,  0 }
+, { "noop", pop3_noop, 0 }
 , { 0, err_unimpl, 0 }
-} ;
+};
+
+void setup(void) {
+  int fd=open(".", O_RDONLY);
+
+  /* logging */
+  if (chdir(auto_qmail) == -1) die_control();
+  if (control_readint(&ctl_log_in,"control/log/pop3_in") == -1)
+    die_control();
+  if (control_readint(&ctl_log_out,"control/log/pop3_out") == -1)
+    die_control();
+  if (control_readint(&ctl_log_fd,"control/log/pop3_fd") == -1)
+    die_control();
+
+  if (ctl_log_in  < 0) ctl_log_in=0;
+  if (ctl_log_out < 0) ctl_log_out=0;
+  if (ctl_log_fd  < 0) ctl_log_fd=0;
+  sserr.fd = ctl_log_fd;
 
-void main(argc,argv)
-int argc;
-char **argv;
+  /* buffer limit for commands */
+  if (control_readint(&ctl_maxcmdlen, "control/maxcmdlen") == -1) die_control();
+  if (ctl_maxcmdlen < 0) ctl_maxcmdlen=0;
+
+  fchdir(fd); close(fd);
+}
+
+int main(int argc, char **argv)
 {
+  char *resp;
+
   sig_alarmcatch(die);
   sig_pipeignore();
- 
+  sserr.fd=0;
+
+  setup();
   if (!argv[1]) die_nomaildir();
   if (chdir(argv[1]) == -1) die_nomaildir();
- 
+
   getlist();
+  /* sorry for this bloat - but we need this for digest-md5 :( */
+  resp=env_get("DIGEST_RESPONSE");
+  if (!resp) {
+    out_err("+OK");
+  } else {
+    stralloc slop = {0};
+    stralloc temp = {0};
+    char tmp[44];
+    int fd=open_read(resp);
+    if (read(fd, &tmp, 33) != 32) {
+      close(fd);
+      out_err("-ERR digest auth failed!");
+      die();
+    }
+    tmp[32]=0;
+    close(fd); unlink(resp);
+    stralloc_copys(&slop, "rspauth=");
+    stralloc_cats(&slop, tmp);
+    slop.s[slop.len]=0;
+    b64encode(&temp,&slop);
+    temp.s[temp.len]=0;
+    doserv();out("+ ");out(temp.s);doeol();flush();
+    if (!stralloc_copys(&temp,"")) return -1;
+    /* xxx: was not tested!!! */
+    for (;;) {
+      int i;
+      if (!stralloc_readyplus(&temp,1)) return -1;
+      i = substdio_get(ssin,temp.s + temp.len,1);
+      if (i != 1) err_syntax();
+      if (temp.s[temp.len] == '\n') break;
+      ++temp.len;
+    }
+    if (temp.len > 0) if (temp.s[temp.len - 1] == '\r') --temp.len;
+    temp.s[temp.len] = 0;
+    doname();out("C: ");out(temp.s);Log("\n");
+    out_err("+OK digest auth was good!");
+  }
+  commands(&ssin,&sserr,pop3commands);
 
-  okay();
-  commands(&ssin,pop3commands);
   die();
+  return 0; /* gcc happyness */
 }
